<html>
<head>
<title>OGRE: OgrePredefinedControllers.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePredefinedControllers.h</h1><a href="OgrePredefinedControllers_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __PredefinedControllers_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __PredefinedControllers_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreController_8h.html">OgreController.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreFrameListener_8h.html">OgreFrameListener.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>"</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00042"></a>00042     <span class="comment">// Controller Values</span>
<a name="l00043"></a>00043     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00046"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html">00046</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html" title="Predefined controller value for getting the latest frame time.">FrameTimeControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications...">FrameListener</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#ab120ed336d85b375181a9a75b0fe6eb">00049</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFrameTime;
<a name="l00050"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#9cc9de7e8a4cf00a493bb356600e5689">00050</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mTimeFactor;
<a name="l00051"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#dcd30d981a8e3012b4f4fff7494cf8ae">00051</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mElapsedTime;
<a name="l00052"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#6b3645fb30af84e4b553d00f7b19e293">00052</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFrameDelay;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054     <span class="keyword">public</span>:
<a name="l00055"></a>00055         <a class="code" href="classOgre_1_1FrameTimeControllerValue.html" title="Predefined controller value for getting the latest frame time.">FrameTimeControllerValue</a>();
<a name="l00056"></a>00056         <span class="keywordtype">bool</span> frameEnded(<span class="keyword">const</span> <a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a> &amp;evt);
<a name="l00057"></a>00057         <span class="keywordtype">bool</span> frameStarted(<span class="keyword">const</span> <a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a> &amp;evt);
<a name="l00058"></a>00058         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00059"></a>00059         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00060"></a>00060         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTimeFactor(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00061"></a>00061         <span class="keywordtype">void</span> setTimeFactor(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tf);
<a name="l00062"></a>00062         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFrameDelay(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00063"></a>00063         <span class="keywordtype">void</span> setFrameDelay(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fd);
<a name="l00064"></a>00064         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getElapsedTime(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00065"></a>00065         <span class="keywordtype">void</span> setElapsedTime(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> elapsedTime);
<a name="l00066"></a>00066     };
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00071"></a><a class="code" href="classOgre_1_1TextureFrameControllerValue.html">00071</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TextureFrameControllerValue.html" title="Predefined controller value for getting / setting the frame number of a texture layer...">TextureFrameControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073     <span class="keyword">protected</span>:
<a name="l00074"></a><a class="code" href="classOgre_1_1TextureFrameControllerValue.html#eff61a7e6136ed9752af3d1c5a29e69d">00074</a>         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* mTextureLayer;
<a name="l00075"></a>00075     <span class="keyword">public</span>:
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1TextureFrameControllerValue.html" title="Predefined controller value for getting / setting the frame number of a texture layer...">TextureFrameControllerValue</a>(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* t);
<a name="l00077"></a>00077 
<a name="l00080"></a>00080         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00083"></a>00083         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     };
<a name="l00086"></a>00086     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00095"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html">00095</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html" title="Predefined controller value for getting / setting a texture coordinate modifications...">TexCoordModifierControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097     <span class="keyword">protected</span>:
<a name="l00098"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#ab6d38dbbf644c1f0cbb4c8d8d1bfc34">00098</a>         <span class="keywordtype">bool</span> mTransU, mTransV;
<a name="l00099"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#20b840b0a76e3d58e1e02b903f41c870">00099</a>         <span class="keywordtype">bool</span> mScaleU, mScaleV;
<a name="l00100"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#a5e4efb0c4b4fbac5f7042e267deedce">00100</a>         <span class="keywordtype">bool</span> mRotate;
<a name="l00101"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#6f82b544431b95702d692e56892e2675">00101</a>         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* mTextureLayer;
<a name="l00102"></a>00102     <span class="keyword">public</span>:
<a name="l00117"></a>00117         <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html" title="Predefined controller value for getting / setting a texture coordinate modifications...">TexCoordModifierControllerValue</a>(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* t, <span class="keywordtype">bool</span> translateU = <span class="keyword">false</span>, <span class="keywordtype">bool</span> translateV = <span class="keyword">false</span>,
<a name="l00118"></a>00118             <span class="keywordtype">bool</span> scaleU = <span class="keyword">false</span>, <span class="keywordtype">bool</span> scaleV = <span class="keyword">false</span>, <span class="keywordtype">bool</span> rotate = <span class="keyword">false</span> );
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00121"></a>00121         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     };
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00138"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html">00138</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html" title="Predefined controller value for setting a single floating- point value in a constant...">FloatGpuParameterControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140     <span class="keyword">protected</span>:
<a name="l00142"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#5e49bf3decab240c3a97c284bd734357">00142</a>         <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* mParams;
<a name="l00144"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#b5735fd67d4c023ecadbc5ec7cc3afd2">00144</a>         <span class="keywordtype">size_t</span> mParamIndex;
<a name="l00145"></a>00145     <span class="keyword">public</span>:
<a name="l00152"></a>00152         <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html" title="Predefined controller value for setting a single floating- point value in a constant...">FloatGpuParameterControllerValue</a>(<a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* params,
<a name="l00153"></a>00153                 <span class="keywordtype">size_t</span> index );
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#4cd25fecd64c347a91c5277f4bfebbce">00155</a>         ~<a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html" title="Predefined controller value for setting a single floating- point value in a constant...">FloatGpuParameterControllerValue</a>() {}
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00158"></a>00158         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160     };
<a name="l00161"></a>00161     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00162"></a>00162     <span class="comment">// Controller functions</span>
<a name="l00163"></a>00163     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00164"></a>00164 
<a name="l00168"></a><a class="code" href="classOgre_1_1PassthroughControllerFunction.html">00168</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PassthroughControllerFunction.html" title="Predefined controller function which just passes through the original source directly...">PassthroughControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value...">ControllerFunction</a>&lt;Real&gt;
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170     <span class="keyword">public</span>:
<a name="l00177"></a>00177         <a class="code" href="classOgre_1_1PassthroughControllerFunction.html" title="Predefined controller function which just passes through the original source directly...">PassthroughControllerFunction</a>(<span class="keywordtype">bool</span> deltaInput = <span class="keyword">false</span>);
<a name="l00178"></a>00178 
<a name="l00181"></a>00181         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00182"></a>00182     };
<a name="l00183"></a>00183 
<a name="l00186"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html">00186</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationControllerFunction.html" title="Predefined controller function for dealing with animation.">AnimationControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value...">ControllerFunction</a>&lt;Real&gt;
<a name="l00187"></a>00187     {
<a name="l00188"></a>00188     <span class="keyword">protected</span>:
<a name="l00189"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html#b3a5975d6690d692328942935fc298a5">00189</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mSeqTime;
<a name="l00190"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html#7ec76f22736a88f3362e007f87f514ae">00190</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mTime;
<a name="l00191"></a>00191     <span class="keyword">public</span>:
<a name="l00198"></a>00198         <a class="code" href="classOgre_1_1AnimationControllerFunction.html" title="Predefined controller function for dealing with animation.">AnimationControllerFunction</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sequenceTime, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeOffset = 0.0f);
<a name="l00199"></a>00199 
<a name="l00202"></a>00202         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00203"></a>00203 
<a name="l00205"></a>00205         <span class="keywordtype">void</span> setTime(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeVal);
<a name="l00207"></a>00207         <span class="keywordtype">void</span> setSequenceTime(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> seqVal);
<a name="l00208"></a>00208     };
<a name="l00209"></a>00209 
<a name="l00210"></a>00210     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00213"></a><a class="code" href="classOgre_1_1ScaleControllerFunction.html">00213</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ScaleControllerFunction.html" title="Predefined controller function which simply scales an input to an output value.">ScaleControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value...">ControllerFunction</a>&lt;Real&gt;
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215     <span class="keyword">protected</span>:
<a name="l00216"></a><a class="code" href="classOgre_1_1ScaleControllerFunction.html#4dd32e9e1e057b4abf391fa5eb4f89e5">00216</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mScale;
<a name="l00217"></a>00217     <span class="keyword">public</span>:
<a name="l00225"></a>00225         <a class="code" href="classOgre_1_1ScaleControllerFunction.html" title="Predefined controller function which simply scales an input to an output value.">ScaleControllerFunction</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scalefactor, <span class="keywordtype">bool</span> deltaInput);
<a name="l00226"></a>00226 
<a name="l00229"></a>00229         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231     };
<a name="l00232"></a>00232 
<a name="l00233"></a>00233     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00253"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html">00253</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html" title="Predefined controller function based on a waveform.">WaveformControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value...">ControllerFunction</a>&lt;Real&gt;
<a name="l00254"></a>00254     {
<a name="l00255"></a>00255     <span class="keyword">protected</span>:
<a name="l00256"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#4d20ceeb97414c820c091c2d2d1cb1ba">00256</a>         <a class="code" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> mWaveType;
<a name="l00257"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#ef4d97d6aa5570d4a4dcaeb11dd3fb34">00257</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBase;
<a name="l00258"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#293bcc15c3553f687b890ad711aab0b7">00258</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFrequency;
<a name="l00259"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#3de22fc6e6c69377856b2f97f47b299b">00259</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mPhase;
<a name="l00260"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#a47e62b3fc8bf48e93e6fd280085b57b">00260</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mAmplitude;
<a name="l00261"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#649691c7cb6c4c4b10547ca66d38df7e">00261</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mDutyCycle;
<a name="l00262"></a>00262 
<a name="l00264"></a>00264         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAdjustedInput(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> input);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266     <span class="keyword">public</span>:
<a name="l00274"></a>00274         <a class="code" href="classOgre_1_1WaveformControllerFunction.html" title="Predefined controller function based on a waveform.">WaveformControllerFunction</a>(<a class="code" href="namespaceOgre.html#bf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> wType, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> base = 0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> frequency = 1, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> phase = 0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> amplitude = 1, <span class="keywordtype">bool</span> deltaInput = <span class="keyword">true</span>, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dutyCycle = 0.5);
<a name="l00275"></a>00275 
<a name="l00278"></a>00278         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280     };
<a name="l00281"></a>00281     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
